<?php

namespace OrganizationsManagement\Controller;

use Exception;
use OrganizationsManagement\Traits\TResponse;
use Zeedhi\Framework\DTO;
use OrganizationsManagement\Service\CollectionErrors as CollectionErrorsService;

class CollectionErrors
{

    use TResponse;

    /**
     * @var CollectionErrorsService
     */
    private $collectionErrorsService;

    /**
     * @param CollectionErrorsService
     */
    public function __construct(CollectionErrorsService $collectionErrorsService)
    {
        $this->collectionErrorsService = $collectionErrorsService;
    }

    public function find(DTO\Request $request, DTO\Response $response)
    {
        try {
            $param = $request->getParameters();
            $page = !empty($param['page']) ? $param['page']  : null;
            $limit = !empty($param['limit'])  ? $param['limit'] : null;
            $order = !empty($param['order'])  ? $param['order']  : null;
            $search = !empty($param['search'])  ? $param['search']  : null;
            $searchIn = !empty($param['search_in'])  ? $param['search_in']  : null;
            $dynamicFilter = !empty($param['dynamic_filter'])  ? $param['dynamic_filter'] : null;

            $data = $this->collectionErrorsService->find($page, $limit, $order, $search, $searchIn, $dynamicFilter);
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
