<?php

namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CollectionErrors
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    private function getDynamicFilterDecoded()
    {
        if(!empty($_REQUEST['dynamic_filter'])) {
            return json_decode(utf8_encode(base64_decode($_REQUEST['dynamic_filter'])), true);
        }
        return array();
    }

    public function getCollectionErros($parametros, $page, $limit, $order, $filtro)
    {
        $startPos = ($page - 1) * $limit;
        $finalPos = $page * $limit;

        $sql = <<<SQL
    SELECT  COUNT(1) OVER () TOTAL_LINES_ZHNEXT, C.* FROM (select NRSEQCONTRATO, CONTRATO, NRPARCNEGOCIO, NMPARCEIRO, ORGANIZACAOPARC, ORGANIZACAOPARC||' - '||NMPARCEIRO AS ORGANIZACAO, IDTIPOORG, 
       NMORGPRINCIPAL, NRORGPRINCIPAL, DTINICOMPET, DTFINCOMPET, CDSERVORCA, NMSERVORCA, IDELEMENTORAIZ, NMELEMENTO, 
       DSTIPOELEMENTO, CDTPMEDIDAVARIAVEL, DSTPMEDIDASERV, QTCONTRATUAL, QTMEDIDA, QTFATURADA, 
       DTULTIMACOLETAOM, QTULTIMAMEDIDAOM, IDSTATUS, DSOBSCOLETA, SERVIDOR, DSSTRINGCONEXAO,
       IDUTWALLET, IDCOLETOR, IDTPCOLETA, IDTPBANCO, IDLOCALCOLETOR, SCRIPT_COUNT_SQL, PREPSTATUS,
       SCRIPT_LOG_SQL, SCRIPT_COUNT_PHP, SCRIPT_LOG_PHP, DTINCLUSAOERRO, NRORG, DTINCLUSAO, DECODE(IDSTATUS, 'O', 'N', 'S') AS IDSEMERRO
  from OM_ANALISE_COLETA(to_date(:DTINICOMPET,'DD/MM/YYYY'), to_date(:DTFINCOMPET,'DD/MM/YYYY'), 20)
  WHERE 1=1
  $filtro
  ) C
              $order
              OFFSET $startPos ROWS FETCH NEXT $limit ROWS ONLY
SQL;

        $result = $this->entityManager->getConnection()->fetchAll($sql, $parametros);

        $total = empty($result) ? 0 : $result[0]['TOTAL_LINES_ZHNEXT'];
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $limit, 'page' => $page, 'total' => $total]];
        return $returnNext;
    }
}