<?php

namespace OrganizationsManagement\Service;

use Exception;
use OrganizationsManagement\Util\Messages;
use OrganizationsManagement\Util\Utilities;
use OrganizationsManagement\Util\InstanceProvider;
use Doctrine\ORM\EntityManager;

class Organization
{
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var \Teknisa\Model\Teknisa\Repositories\Organizacao
     */
    private $organizationRepository;

    /**
     * SlaclienteParam constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
        $this->organizationRepository = InstanceProvider::getRepository()->getOrganizacao();
    }

    /**
     * @param $cdcliente
     * @return array
     */
    public function findSaasOrganizations(): array
    {
        return $this->organizationRepository->findSaasOrganizations('');
    }
}
