/*
TEKNISA SOFTWARE

NOME: GERA_MOVI_PESAGEM

DESCRIO:
   PROCEDIMENTOS PARA GERAO DAS MOVIMENTAES APS PESAGEM

CRIAO:
   26/07/2017 - FABRICIO MARCELO SILVA

@C:\WEB_610\SQL\END_CONV\ORACLE\520K_ESTSTPO_GERA_MOVI_PESAGEM.SQL

RAISE_APPLICATION_ERROR(-20501,, TRUE);

*/

create or replace PROCEDURE GERA_MOVI_PESAGEM(P_CDFILIAL    IN FILIAL.CDFILIAL%TYPE,
                            P_NRLANCTONF  IN NOTAFISCAL.NRLANCTONF%TYPE,
                            P_CDOPERADOR  IN OPERADOR.CDOPERADOR%TYPE,
                            P_ERRO OUT VARCHAR2)
AS
   V_NRLANCTONF     VARCHAR2(10);
   V_CDEMPRESA      VARCHAR2(2);
   V_CDFILIRECE     VARCHAR2(4);
   V_CDFORNECED     VARCHAR2(21);
   V_NRNOTAFISC     VARCHAR2(20);
   V_DTMOVI         DATE;
   V_CDTPORETIPADR  VARCHAR2(2);
   V_CDSETORESTOQ   VARCHAR2(4);
   V_CDCENTCUST     VARCHAR2(4);

   V_IDNEWLANCEST    VARCHAR2(1);
   V_IDNEWLANCTRANS  VARCHAR2(1);
   V_IDNEWLANCTRETI  VARCHAR2(1);
   V_IDNEWLANCDEVO   VARCHAR2(1);
   V_NRLANCESTQ_E    VARCHAR2(20);
   V_NRLANCESTQ_TS   VARCHAR2(20);
   V_NRLANCESTQ_TE   VARCHAR2(20);
   V_NRLANCESTQ_R    VARCHAR2(20);
   V_NRLANCTRANS     VARCHAR2(20);
   V_NRRETIRADA      VARCHAR2(20);
   V_NRLANCDEVO      VARCHAR2(20);
   V_NRLANCESTQ_D    VARCHAR2(20);

   V_NRSEQITENTR    NUMBER;
   V_NRSEQITTRANS   NUMBER;
   V_NRSEQITTRETI   NUMBER;

   V_QTDEESTO       NUMBER;
   V_NRSERIE        VARCHAR2(5);

   V_ERRO           VARCHAR2(500);
BEGIN
   V_IDNEWLANCEST   := 'S';
   V_IDNEWLANCTRANS := 'S';
   V_IDNEWLANCTRETI := 'S';
   V_IDNEWLANCDEVO  := 'S';

   V_NRSEQITENTR  := 0;
   V_NRSEQITTRANS := 0;
   V_NRSEQITTRETI := 0;

   V_ERRO := NULL;

   BEGIN
   SELECT N.NRLANCTONF, N.CDEMPRESA, N.CDFILIRECE, N.CDFORNECED, N.NRNOTAFISC, TRUNC(SYSDATE), P.CDTPORETIPADR, P.CDSETORESTOQ, S.CDCENTCUST
     INTO V_NRLANCTONF, V_CDEMPRESA, V_CDFILIRECE, V_CDFORNECED, V_NRNOTAFISC, V_DTMOVI, V_CDTPORETIPADR, V_CDSETORESTOQ, V_CDCENTCUST
     FROM NOTAFISCAL N, PARAMINTBALANCA P, SETOR S
    WHERE N.CDFILIAL   = P_CDFILIAL
      AND N.NRLANCTONF = P_NRLANCTONF
      AND P.CDFILIAL   = N.CDFILIRECE
      AND S.CDSETOR    = P.CDSETORESTOQ;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDEMPRESA := NULL; V_CDFILIRECE := NULL; V_CDFORNECED := NULL; V_NRNOTAFISC := NULL;
         V_DTMOVI := SYSDATE; V_CDTPORETIPADR := NULL; V_CDSETORESTOQ := NULL; V_CDCENTCUST := NULL;
   END;

   UPDATE ITEMPRODUTO
      SET IDPESADO = 'S'
    WHERE CDFILIAL = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   FOR C_ITENS IN (SELECT I.CDPRODUTO, R.CDPRODESTO, R.VRFATOCONV,
                          I.QTITEMPROD, I.VRUNITITEM,
                          I.CDPRODEMBALAGEM AS CDPRODUTOEMB, P.CDPRODESTO AS CDPRODESTOEMB, P.VRFATOCONV AS VRFATOCONVEMB,
                          P.CDARVPROD, P.NMPRODUTO,
                          I.QTDIFEPESAPROD, (I.VRUNITITEM / P.VRFATOCONV) AS VRUNITEMB,
                          I.CDALMOXARIFE AS CDALMOXARIFE_S, I.CDLOCALESTOQ AS CDLOCALESTOQ_S,
                          NVL(PF.CDALMOXARIFE,' ') AS CDALMOXARIFE_E, NVL(PF.CDLOCALESTOQ,' ') AS CDLOCALESTOQ_E, I.NRLOTEESTQ, I.NRSUBLOTE,
                          NVL(I.IDACAO, '1') AS IDACAO
                     FROM ITEMPRODUTO I, PRODUTO P, PRODFILI PF, PRODUTO R
                    WHERE I.CDFILIAL   = P_CDFILIAL
                      AND I.NRLANCTONF = P_NRLANCTONF
                      AND P.CDPRODUTO  = I.CDPRODEMBALAGEM
                      AND R.CDPRODUTO  = I.CDPRODUTO
                      AND PF.CDFILIAL  = V_CDFILIRECE
                      AND PF.CDPRODUTO = P.CDPRODESTO
                    ORDER BY I.IDACAO)
   LOOP

      -- Gera transferncia de estoque do produto
      INSERT INTO PRODLCESTOQ
         (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
         (SELECT V_CDFILIRECE, C_ITENS.CDALMOXARIFE_S, C_ITENS.CDLOCALESTOQ_S, C_ITENS.CDPRODUTO
            FROM PRODFILI
           WHERE CDFILIAL  = V_CDFILIRECE
             AND CDPRODUTO = C_ITENS.CDPRODUTO
             AND NVL(IDCNTRESTOQ, 'S') <> 'N'
           MINUS
          SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
            FROM PRODLCESTOQ
           WHERE CDFILIAL     = V_CDFILIRECE
             AND CDALMOXARIFE = C_ITENS.CDALMOXARIFE_S
             AND CDLOCALESTOQ = C_ITENS.CDLOCALESTOQ_S
             AND CDPRODUTO    = C_ITENS.CDPRODUTO);

      -- Transferencia (Lanamento de sada)
      IF C_ITENS.CDALMOXARIFE_E <> C_ITENS.CDALMOXARIFE_S THEN
         IF V_IDNEWLANCTRANS = 'S' THEN
            NOVO_CODIGO_SC('LANCTOEST' || P_CDFILIAL, V_NRLANCESTQ_TS);

            INSERT INTO LANCTOESTOQ
              (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ,
               DSLANCESTQ, CDFILIMOVI, CDOPERADOR)
            VALUES
              (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TS,11,10), '4', V_DTMOVI,
               'Transf. de Est. e conforme pesagem. NF: '|| V_NRNOTAFISC, V_CDFILIRECE, P_CDOPERADOR);

            -- Transferencia (Lanamento de entrada)
            NOVO_CODIGO_SC('LANCTOEST' || P_CDFILIAL, V_NRLANCESTQ_TE);

            INSERT INTO LANCTOESTOQ
              (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ,
               DSLANCESTQ, CDFILIMOVI, CDOPERADOR)
            VALUES
              (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TE,11,10), '2', V_DTMOVI,
               'Transf. de Est. conforme pesagem. NF: '|| V_NRNOTAFISC, V_CDFILIRECE, P_CDOPERADOR);

            -- Gera transferncia
            NOVO_CODIGO_SC('NRTRANSESTQ' || P_CDFILIAL, V_NRLANCTRANS);

            INSERT INTO CTRLMOVIESTQ
              (CDFILIAL, NRCTRLMOVEST, CDFILIALENTR, NRLANESTENTR,
               CDFILIALSAID, NRLANESTSAID, CDALMOXENTR, CDALMOXSAID,
               CDLCESTENTR, CDLCESTSAID, DTMOVIESTQ, NRREQUESTO)
            VALUES
               (V_CDFILIRECE, SUBSTR(V_NRLANCTRANS,11,10), P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TE,11,10),
                P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TS,11,10), C_ITENS.CDALMOXARIFE_E, C_ITENS.CDALMOXARIFE_S,
                C_ITENS.CDLOCALESTOQ_E, C_ITENS.CDLOCALESTOQ_S, V_DTMOVI, NULL);

            V_IDNEWLANCTRANS := 'N';
         END IF;

         V_NRSEQITTRANS := V_NRSEQITTRANS + 1;

         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,
             VRUNILANCTO, VRTOTLANCTO, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
             CDPRODMOVI, IDEVOLESTOQ, DSLANCESTIT, CDFILIMOVI, CDALMOXARIFE,
             CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, NRLANCORIGRP, CDOPERADOR,
             VRLANCTOBRUT, VRLANCTOEST, QTTOTLANCTO, NRSEQITEMREQEST)
         VALUES
            (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TS,11,10), LPAD(RTRIM(TO_CHAR(V_NRSEQITTRANS)), 4, '0'), C_ITENS.CDPRODUTO, (C_ITENS.QTITEMPROD * C_ITENS.VRFATOCONV),
             C_ITENS.VRUNITITEM, (C_ITENS.QTITEMPROD * C_ITENS.VRUNITITEM), '4', V_DTMOVI, '4',
             C_ITENS.CDPRODESTO, 'S', NULL, V_CDFILIRECE, C_ITENS.CDALMOXARIFE_S,
             C_ITENS.CDLOCALESTOQ_S, C_ITENS.NRLOTEESTQ, C_ITENS.NRSUBLOTE, NULL, NULL,
             (C_ITENS.VRUNITITEM / C_ITENS.VRFATOCONV), (C_ITENS.VRUNITITEM / C_ITENS.VRFATOCONV), C_ITENS.QTITEMPROD, NULL);

         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,
             VRUNILANCTO, VRTOTLANCTO, IDTIPOMOVI, DTLANCMOVI, IDORDEMCLC,
             CDPRODMOVI, IDEVOLESTOQ, DSLANCESTIT, CDFILIMOVI, CDALMOXARIFE,
             CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, NRLANCORIGRP, CDOPERADOR,
             VRLANCTOBRUT, VRLANCTOEST, QTTOTLANCTO, NRSEQITEMREQEST, VRCUSTENTR)
         VALUES
            (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TE,11,10), LPAD(RTRIM(TO_CHAR(V_NRSEQITTRANS)), 4, '0'), C_ITENS.CDPRODUTO, (C_ITENS.QTITEMPROD * C_ITENS.VRFATOCONV),
             C_ITENS.VRUNITITEM, (C_ITENS.QTITEMPROD * C_ITENS.VRUNITITEM), '2', V_DTMOVI, '2',
             C_ITENS.CDPRODESTO, 'S', NULL, V_CDFILIRECE, C_ITENS.CDALMOXARIFE_E,
             C_ITENS.CDLOCALESTOQ_E, C_ITENS.NRLOTEESTQ, C_ITENS.NRSUBLOTE, NULL, NULL,
             (C_ITENS.VRUNITITEM / C_ITENS.VRFATOCONV), (C_ITENS.VRUNITITEM / C_ITENS.VRFATOCONV), C_ITENS.QTITEMPROD, NULL, (C_ITENS.VRUNITITEM / C_ITENS.VRFATOCONV));
      END IF;

      -- Gerar Entrada
      IF C_ITENS.IDACAO = '0' THEN

         INSERT INTO PRODLCESTOQ
            (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
            (SELECT V_CDFILIRECE, C_ITENS.CDALMOXARIFE_E, C_ITENS.CDLOCALESTOQ_E, C_ITENS.CDPRODUTOEMB
               FROM PRODFILI
              WHERE CDFILIAL  = V_CDFILIRECE
                AND CDPRODUTO = C_ITENS.CDPRODUTOEMB
                AND NVL(IDCNTRESTOQ, 'S') <> 'N'
              MINUS
             SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
               FROM PRODLCESTOQ
              WHERE CDFILIAL     = V_CDFILIRECE
                AND CDALMOXARIFE = C_ITENS.CDALMOXARIFE_E
                AND CDLOCALESTOQ = C_ITENS.CDLOCALESTOQ_E
                AND CDPRODUTO    = C_ITENS.CDPRODUTOEMB);

         IF V_IDNEWLANCEST = 'S' THEN
            NOVO_CODIGO_SC('LANCTOEST' || P_CDFILIAL, V_NRLANCESTQ_E);

            INSERT INTO LANCTOESTOQ
               (CDFILIAL, NRLANCESTQ, DSLANCESTQ,
                IDTPLANCTO, CDTIPOOPER, DTLANCESTQ,
                IDENTRSAIDOP, CDFILIMOVI, NRLANCTONF)
            VALUES
               (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_E,11,10), 'Entr. div. da pesagem de merc. NF: '|| V_NRNOTAFISC,
                '2', '10', V_DTMOVI,
                'E', V_CDFILIRECE, NULL);

            V_IDNEWLANCEST := 'N';
         END IF;

         V_NRSEQITENTR := V_NRSEQITENTR + 1;

         INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
             QTLANCTOEST, VRUNILANCTO,VRTOTLANCTO, QTTOTLANCTO,
             CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ,
             NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, DTLANCMOVI,
             IDORDEMCLC, VRLANCTOEST, VRLANCTOBRUT, VRCUSTENTR)
         VALUES
            (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_E,11,10), LPAD(RTRIM(TO_CHAR(V_NRSEQITENTR)), 4, '0'), C_ITENS.CDPRODUTOEMB,
             (C_ITENS.QTDIFEPESAPROD * C_ITENS.VRFATOCONVEMB), C_ITENS.VRUNITEMB, (C_ITENS.QTDIFEPESAPROD * C_ITENS.VRUNITEMB), C_ITENS.QTDIFEPESAPROD,
             C_ITENS.CDPRODESTOEMB, V_CDFILIRECE, C_ITENS.CDALMOXARIFE_E, C_ITENS.CDLOCALESTOQ_E,
             C_ITENS.NRLOTEESTQ, C_ITENS.NRSUBLOTE, '2', V_DTMOVI,
             '2', C_ITENS.VRUNITEMB, C_ITENS.VRUNITEMB, C_ITENS.VRUNITEMB);
      ELSE
         -- Gerar Retirada
         IF C_ITENS.IDACAO = '2' THEN
            -- verifica quantidade em estoque
            BEGIN
               SELECT MAX(QTESTOQDIA)
                 INTO V_QTDEESTO
                 FROM POSESTDIA P
                WHERE P.CDFILIAL     = V_CDFILIRECE
                  AND P.CDALMOXARIFE = C_ITENS.CDALMOXARIFE_E
                  AND P.CDLOCALESTOQ = C_ITENS.CDLOCALESTOQ_E
                  AND P.NRLOTEESTQ   = C_ITENS.NRLOTEESTQ
                  AND P.NRSUBLOTE    = C_ITENS.NRSUBLOTE
                  AND P.CDPRODUTO    = C_ITENS.CDPRODESTOEMB
                  AND P.QTESTOQDIA <> 0
                  AND P.DTPOSIESTQ <= DTPOSICAO_POSESTDIA(P.CDFILIAL, P.CDPRODUTO, P.CDALMOXARIFE, P.CDLOCALESTOQ, P.NRLOTEESTQ, P.NRSUBLOTE, V_DTMOVI + 1);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_QTDEESTO := 0;
            END;

            -- Se possuir saldo em estoque
            IF (V_QTDEESTO >= (C_ITENS.QTDIFEPESAPROD * C_ITENS.VRFATOCONVEMB)) THEN

               INSERT INTO PRODLCESTOQ
                  (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
                  (SELECT V_CDFILIRECE, C_ITENS.CDALMOXARIFE_E, C_ITENS.CDLOCALESTOQ_E, C_ITENS.CDPRODUTOEMB
                     FROM PRODFILI
                    WHERE CDFILIAL  = V_CDFILIRECE
                      AND CDPRODUTO = C_ITENS.CDPRODUTOEMB
                      AND NVL(IDCNTRESTOQ, 'S') <> 'N'
                    MINUS
                   SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
                     FROM PRODLCESTOQ
                    WHERE CDFILIAL     = V_CDFILIRECE
                      AND CDALMOXARIFE = C_ITENS.CDALMOXARIFE_E
                      AND CDLOCALESTOQ = C_ITENS.CDLOCALESTOQ_E
                      AND CDPRODUTO    = C_ITENS.CDPRODUTOEMB);


               IF V_IDNEWLANCTRETI = 'S' THEN
                  NOVO_CODIGO_SC('LANCTOEST' || P_CDFILIAL, V_NRLANCESTQ_R);

                  INSERT INTO LANCTOESTOQ
                    (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ,
                     CDFILIMOVI, CDOPERADOR, CDALMOXARIFE, CDLOCALESTOQ)
                  VALUES
                    (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_R,11,10), '3', V_DTMOVI, 'Retirada de divergncias na pesagem - NF ' || V_NRNOTAFISC,
                     V_CDFILIRECE, P_CDOPERADOR, NULL, NULL);

                  NOVO_CODIGO_SC('RETIESTO' || P_CDFILIAL, V_NRRETIRADA);

                  INSERT INTO RETIRADAESTO
                    (CDFILIAL,   NRRETEST, DTRETEST,   DSRETEST,  CDFILIALLAN,
                     NRLANCESTQ, CDSETOR,  CDCENTCUST, NRORDPROD, NRREQUESTO)
                  VALUES
                    (P_CDFILIAL,  SUBSTR(V_NRRETIRADA,11,10), V_DTMOVI, 'Retirada de divergncias na pesagem - NF ' || V_NRNOTAFISC, P_CDFILIAL,
                     SUBSTR(V_NRLANCESTQ_R,11,10), V_CDSETORESTOQ, V_CDCENTCUST, NULL, NULL);

                  V_IDNEWLANCTRETI := 'N';
               END IF;

               V_NRSEQITTRETI := V_NRSEQITTRETI + 1;

               INSERT INTO ITLANCTOEST
                 (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, DSLANCESTIT,
                  CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDFILIMOVI, CDPRODMOVI,
                  IDORDEMCLC, DTLANCMOVI, IDEVOLESTOQ, CDTIPORETI, CDCENTCUST, QTTOTLANCTO,
                  IDTIPOMOVI, QTLANCTOEST, VRUNILANCTO, VRTOTLANCTO,
                  QTDEVOLESTOQ, VRLANCTOEST , VRLANCTOBRUT, NRREQUESTO)
               VALUES
                 (P_CDFILIAL, SUBSTR(V_NRLANCESTQ_R,11,10), LPAD(RTRIM(TO_CHAR(V_NRSEQITTRETI)), 4, '0'), C_ITENS.CDPRODUTOEMB, NULL,
                  C_ITENS.CDALMOXARIFE_E, C_ITENS.CDLOCALESTOQ_E, C_ITENS.NRLOTEESTQ, C_ITENS.NRSUBLOTE, V_CDFILIRECE, C_ITENS.CDPRODESTOEMB,
                  '9', V_DTMOVI, 'S', V_CDTPORETIPADR, V_CDCENTCUST, C_ITENS.QTDIFEPESAPROD,
                  '3', (C_ITENS.QTDIFEPESAPROD * C_ITENS.VRFATOCONVEMB),  C_ITENS.VRUNITEMB, (C_ITENS.QTDIFEPESAPROD * C_ITENS.VRUNITEMB),
                  0, C_ITENS.VRUNITEMB, C_ITENS.VRUNITEMB, NULL);
            ELSE
               V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
            END IF;
         ELSE
            -- Gerar Devolucao
            IF C_ITENS.IDACAO = '3' THEN

               -- verifica quantidade em estoque
               BEGIN
                  SELECT MAX(QTESTOQDIA)
                    INTO V_QTDEESTO
                    FROM POSESTDIA P
                   WHERE P.CDFILIAL     = V_CDFILIRECE
                     AND P.CDALMOXARIFE = C_ITENS.CDALMOXARIFE_E
                     AND P.CDLOCALESTOQ = C_ITENS.CDLOCALESTOQ_E
                     AND P.NRLOTEESTQ   = C_ITENS.NRLOTEESTQ
                     AND P.NRSUBLOTE    = C_ITENS.NRSUBLOTE
                     AND P.CDPRODUTO    = C_ITENS.CDPRODESTOEMB
                     AND P.QTESTOQDIA <> 0
                     AND P.DTPOSIESTQ <= DTPOSICAO_POSESTDIA(P.CDFILIAL, P.CDPRODUTO, P.CDALMOXARIFE, P.CDLOCALESTOQ, P.NRLOTEESTQ, P.NRSUBLOTE, V_DTMOVI + 1);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_QTDEESTO := 0;
               END;

               -- Se possuir saldo em estoque
               IF (V_QTDEESTO >= (C_ITENS.QTDIFEPESAPROD * C_ITENS.VRFATOCONVEMB)) THEN

                  IF V_IDNEWLANCDEVO = 'S' THEN
                     NOVO_CODIGO_SC('LANCNF/FILIAL'||P_CDFILIAL, V_NRLANCDEVO);
                     V_NRLANCDEVO := SUBSTR(V_NRLANCDEVO,11,10);

                     NOVO_CODIGO_SC('LANCTOEST'||P_CDFILIAL, V_NRLANCESTQ_D);
                     V_NRLANCESTQ_D := SUBSTR(V_NRLANCESTQ_D,11,10);

                     BEGIN
                        SELECT CDSERIE
                          INTO V_NRSERIE
                          FROM FILIAL
                         WHERE CDFILIAL = V_CDFILIRECE;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_NRSERIE := NULL;
                     END;

                     GERA_NOTAFISCAL_CORPO(P_CDFILIAL    => P_CDFILIAL,
                                           P_CDFILIEMIT  => V_CDFILIRECE,
                                           P_CDEMPRESA   => V_CDEMPRESA,
                                           P_CDTIPOOPER  => '06',
                                           P_DTENTRSAID  => V_DTMOVI,
                                           P_IDSISTEMA   => 'DFS',
                                           P_PRXLANCTONF => V_NRLANCDEVO,
                                           P_PRXLANCESTQ => V_NRLANCESTQ_D,
                                           P_CDSERIE     => V_NRSERIE,
                                           P_CDCLIENTE   => V_CDFORNECED,
                                           P_NRLANCTONF  => V_NRLANCDEVO,
                                           P_NRLANCESTQ  => V_NRLANCESTQ_D);

                     V_IDNEWLANCDEVO := 'N';
                  END IF;

                  GERA_NOTAFISCAL_PRODUTO(P_CDFILIAL     => P_CDFILIAL,
                                          P_NRLANCTONF   => V_NRLANCDEVO,
                                          P_CDPRODUTO    => C_ITENS.CDPRODUTOEMB,
                                          P_CDPRODEMIS   => C_ITENS.CDARVPROD,
                                          P_DSPRODEMIS   => C_ITENS.NMPRODUTO,
                                          P_VRUNITITEM   => C_ITENS.VRUNITEMB,
                                          P_VRDESCITEM   => 0,
                                          P_CDALMOXARIFE => C_ITENS.CDALMOXARIFE_E,
                                          P_CDLOCALESTOQ => C_ITENS.CDLOCALESTOQ_E,
                                          P_NRLOTEESTQ   => C_ITENS.NRLOTEESTQ,
                                          P_NRSUBLOTE    => C_ITENS.NRSUBLOTE,
                                          P_QTITEMPROD   => C_ITENS.QTDIFEPESAPROD);
               ELSE
                  V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
               END IF;
            END IF;
         END IF;
      END IF;
   END LOOP;

   -- Atuliza estoque referente a transferncia de estoque (sada)
   ATUALIZA_ESTOQUE(V_CDFILIRECE, V_DTMOVI, TO_DATE(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TS,11,10), NULL);

   /* Atualiza a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
   FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                              CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                         FROM MOVILOTE
                        WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_TS,11,10)
                          AND CDFILIAL   = V_CDFILIRECE)
   LOOP
      UPDATE ITLANCTOEST
         SET IDEVOLESTOQ  = 'N'
       WHERE CDFILIAL     = P_CDFILIAL
         AND NRLANCESTQ   = SUBSTR(V_NRLANCESTQ_TS,11,10)
         AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
         AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
         AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
         AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
         AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

      V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
   END LOOP;

   DELETE MOVILOTE
    WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_TS,11,10);


   -- Atuliza estoque referente a transferncia de estoque (Entrada)
   ATUALIZA_ESTOQUE(V_CDFILIRECE, V_DTMOVI, TO_DATE(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQ_TE,11,10), NULL);

   /* Atualiza a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
   FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                              CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                         FROM MOVILOTE
                        WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_TE,11,10)
                          AND CDFILIAL   = V_CDFILIRECE)
   LOOP
      UPDATE ITLANCTOEST
         SET IDEVOLESTOQ  = 'N'
       WHERE CDFILIAL     = P_CDFILIAL
         AND NRLANCESTQ   = SUBSTR(V_NRLANCESTQ_TE,11,10)
         AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
         AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
         AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
         AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
         AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

      V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
   END LOOP;

   DELETE MOVILOTE
    WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_TE,11,10);


   -- Atuliza estoque referente a Gerao de Entrada
   ATUALIZA_ESTOQUE(V_CDFILIRECE, V_DTMOVI, TO_DATE(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQ_E,11,10), NULL);

   /* Atualiza a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
   FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                              CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                         FROM MOVILOTE
                        WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_E,11,10)
                          AND CDFILIAL   = V_CDFILIRECE)
   LOOP
      UPDATE ITLANCTOEST
         SET IDEVOLESTOQ  = 'N'
       WHERE CDFILIAL     = P_CDFILIAL
         AND NRLANCESTQ   = SUBSTR(V_NRLANCESTQ_E,11,10)
         AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
         AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
         AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
         AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
         AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

      V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
   END LOOP;

   DELETE MOVILOTE
    WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_E,11,10);


   -- Atuliza estoque referente a Gerao de Retirada
   ATUALIZA_ESTOQUE(V_CDFILIRECE, V_DTMOVI, TO_DATE(SYSDATE), P_CDFILIAL, SUBSTR(V_NRLANCESTQ_R,11,10), NULL);

   /* Atualiza a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
   FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                              CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                         FROM MOVILOTE
                        WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_R,11,10)
                          AND CDFILIAL   = V_CDFILIRECE)
   LOOP
      UPDATE ITLANCTOEST
         SET IDEVOLESTOQ  = 'N'
       WHERE CDFILIAL     = P_CDFILIAL
         AND NRLANCESTQ   = SUBSTR(V_NRLANCESTQ_R,11,10)
         AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
         AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
         AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
         AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
         AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

      V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
   END LOOP;

   DELETE MOVILOTE
    WHERE NRMOVILOTE = P_CDFILIAL||SUBSTR(V_NRLANCESTQ_R,11,10);


   -- Se gerou NF de Devoluo
   IF V_IDNEWLANCDEVO = 'N' THEN
      INSERT INTO ITEMNOTAFISC
         (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
      VALUES
         (P_CDFILIAL, V_NRLANCDEVO, LPAD(1, 3, '0'), P_CDFILIAL, V_NRLANCTONF);

      GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIAL   => P_CDFILIAL,
                                 P_NRLANCTONF => V_NRLANCDEVO,
                                 P_NRLANCESTQ => V_NRLANCESTQ_D);

      ATUALIZA_ESTOQUE(V_CDFILIRECE, V_DTMOVI, TO_DATE(SYSDATE), P_CDFILIAL, V_NRLANCESTQ_D);

      /* Atualiza a Itlanctoest para no evoluir estoque caso encontre erro ao atualizar o estoque */
      FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                 CDPRODUTO, NRLOTEESTQ, NRSUBLOTE
                            FROM MOVILOTE
                           WHERE NRMOVILOTE = P_CDFILIAL||V_NRLANCESTQ_D
                             AND CDFILIAL   = V_CDFILIRECE)
      LOOP
         UPDATE ITLANCTOEST
            SET IDEVOLESTOQ  = 'N'
          WHERE CDFILIAL     = P_CDFILIAL
            AND NRLANCESTQ   = V_NRLANCESTQ_D
            AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
            AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
            AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
            AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
            AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;

         V_ERRO := 'Nota Fiscal: '||V_NRNOTAFISC||'. Algum(ns) produto(s) tornariam o estoque irregular.';
      END LOOP;

      DELETE MOVILOTE
       WHERE NRMOVILOTE = P_CDFILIAL||V_NRLANCESTQ_D;
   END IF;

   IF V_ERRO IS NULL THEN
      COMMIT;
   END IF;

   P_ERRO := V_ERRO;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_MOVI_PESAGEM','6.49.046'); END;
/
