<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class GpePontoacesso extends \Doctrine\ORM\EntityRepository {
    
    public function getPontoAcessoVinculo($nrorg, $nrvinculom): ?object {
        $pontoAcessoEstrutGeren = $this->getPontoAcessoVinculoEstrutGeren($nrorg, $nrvinculom);
        if (!empty($pontoAcessoEstrutGeren)) {
            return $pontoAcessoEstrutGeren;
        }
        return $this->getPontoAcessoVinculoEstrutLegal($nrorg, $nrvinculom);
    }
    
    public function getPontoAcessoVinculoEstrutGeren($nrorg, $nrvinculom): ?object {
        
        $gpe_pontoacesso = Repositories::GPE_PONTOACESSO;
        $gpe_vinculom = Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        
$sql = <<<SQL
SELECT pa
FROM $gpe_vinculom vm 
JOIN $gpe_vinculoh vh WITH vh.dtmescompetenc = (
    SELECT MAX(vhh.dtmescompetenc) FROM $gpe_vinculoh vhh WHERE vhh.nrvinculom = vh.nrvinculom AND vhh.nrorg = vh.nrorg
)
    AND vh.nrorg = vm.nrorg
    AND vh.nrvinculom = vm.nrvinculom
JOIN $gpe_pontoacesso pa WITH pa.nrestruturam = vh.nrestrutgeren
    AND pa.nrorg = vm.nrorg
WHERE vm.nrvinculom = :p_nrvinculom
    AND vm.nrorg = :p_nrorg
SQL;
        
        $params = array(
            'p_nrorg'       => $nrorg,
            'p_nrvinculom'  => $nrvinculom,
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return !empty($result) ? $result[0] : null;
    }
    
    public function getPontoAcessoVinculoEstrutLegal($nrorg, $nrvinculom): ?object {
        
        $gpe_pontoacesso = Repositories::GPE_PONTOACESSO;
        $gpe_vinculom = Repositories::GPE_VINCULOM;
        $gpe_vinculoh = Repositories::GPE_VINCULOH;
        
$sql = <<<SQL
SELECT pa
FROM $gpe_vinculom vm 
JOIN $gpe_vinculoh vh WITH vh.dtmescompetenc = (
    SELECT MAX(vhh.dtmescompetenc) FROM $gpe_vinculoh vhh WHERE vhh.nrvinculom = vh.nrvinculom AND vhh.nrorg = vh.nrorg
)
    AND vh.nrorg = vm.nrorg
    AND vh.nrvinculom = vm.nrvinculom
JOIN $gpe_pontoacesso pa WITH pa.nrestruturam = vh.nrestrutlegal
    AND pa.nrorg = vm.nrorg
WHERE vm.nrvinculom = :p_nrvinculom
    AND vm.nrorg = :p_nrorg
SQL;
        
        $params = array(
            'p_nrorg'       => $nrorg,
            'p_nrvinculom'  => $nrvinculom,
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return !empty($result) ? $result[0] : null;
    }
    
}